import { ic, nat32, None, Opt, Some, update } from 'azle';
import { PerfResult } from '../../perf_result';

let opt_init_heap_storage: { [key: string]: Opt<boolean> | undefined } = {};

export const opt_init_stack = update([nat32], PerfResult, (num_inits) => {
    const perf_start = ic.performanceCounter(0);

    let i = 0;

    while (i < num_inits) {
        let value: Opt<boolean> = i % 2 === 0 ? Some(true) : None;
        // TODO std::convert::identity(value); consider something like Rust to ensure the value assignment above is never optimized away
        i += 1;
    }

    const perf_end = ic.performanceCounter(0);

    return {
        wasm_body_only: perf_end - perf_start,
        wasm_including_prelude: ic.performanceCounter(0)
    };
});

export const opt_init_heap = update([nat32], PerfResult, (num_inits) => {
    const perf_start = ic.performanceCounter(0);

    let i = 0;

    while (i < num_inits) {
        opt_init_heap_storage[`bool${i}`] = i % 2 === 0 ? Some(true) : None;
        i += 1;
    }

    const perf_end = ic.performanceCounter(0);

    return {
        wasm_body_only: perf_end - perf_start,
        wasm_including_prelude: ic.performanceCounter(0)
    };
});
