// Named Imports
import { Canister } from 'azle';
import {
    myVariantToMyDeepVariant,
    myFathomlessVariantToMyCavernousVariant,
    returnVec,
    returnFathomlessVec,
    returnWeird,
    returnFathomlessCanister,
    makeCavernousRecord,
    typeCheck
} from './import_coverage';
import {
    collectIcaco,
    cutPineapple,
    separateArilsFromPith,
    buyHoneydew,
    keepIlamaClean,
    addSigFigs,
    checkCanister,
    checkWatermelonForSeeds,
    compareApplesToOranges,
    handleFarkleberries,
    getManagementPeach,
    pitOlives,
    peelBanana,
    putTheCoconutInTheLime,
    isMangoTrickyToEat,
    isFruitPrepared,
    removeRambutanSkins,
    dirtyIlama,
    pickElderberry
} from './azle_coverage';
import {
    compareStars,
    helloTextAlias,
    helloAzleTextAlias,
    helloMixedTextAlias,
    helloDeepTextAlias,
    helloStirredTextAlias,
    getDeepBlob,
    deepEmptyAlias,
    getNumberAliases,
    passPrincipal,
    getReservedAlias,
    simpleDeepQuery,
    simpleAzleQuery,
    simpleQuery,
    checkCanisterAlias,
    getMyRecord,
    getMyRecordAlias,
    getSuperAlias,
    getManualAlias,
    returnFuncAlias,
    setStable,
    getStable
} from './type_alias_decls';
import { checkPrimAliases } from './ts_primitives';

// Not Named Imports
import './azle_coverage/fruit'; // Shouldn't do anything. It's just here to make sure it doesn't do anything

export default Canister({
    myVariantToMyDeepVariant,
    myFathomlessVariantToMyCavernousVariant,
    returnVec,
    returnFathomlessVec,
    returnWeird,
    returnFathomlessCanister,
    makeCavernousRecord,
    typeCheck,
    collectIcaco,
    cutPineapple,
    separateArilsFromPith,
    buyHoneydew,
    keepIlamaClean,
    addSigFigs,
    checkCanister,
    checkWatermelonForSeeds,
    compareApplesToOranges,
    handleFarkleberries,
    getManagementPeach,
    pitOlives,
    peelBanana,
    putTheCoconutInTheLime,
    isMangoTrickyToEat,
    isFruitPrepared,
    removeRambutanSkins,
    dirtyIlama,
    pickElderberry,
    compareStars,
    helloTextAlias,
    helloAzleTextAlias,
    helloMixedTextAlias,
    helloDeepTextAlias,
    helloStirredTextAlias,
    getDeepBlob,
    deepEmptyAlias,
    getNumberAliases,
    passPrincipal,
    getReservedAlias,
    simpleDeepQuery,
    simpleAzleQuery,
    simpleQuery,
    checkCanisterAlias,
    getMyRecord,
    getMyRecordAlias,
    getSuperAlias,
    getManualAlias,
    returnFuncAlias,
    setStable,
    getStable,
    checkPrimAliases
});
