# Summary

-   [The Azle Book (Beta)](./the_azle_book.md)
-   [Get Started](./get_started.md)
-   [Examples](./rest_based_examples.md)
-   [Deployment](./deployment.md)
-   [Server](./server.md)
-   [Assets]()
-   [Debugging]()
-   [Limitations]()
-   [Authentication]()
-   [Databases]()
-   [fetch]()
-   [npm]()
-   [Cycles]()
-   [Tokens]()
-   [Bitcoin]()
-   [Ethereum]()
-   [Reference](./reference_http/reference.md)
    -   [Autoreload](./reference_http/autoreload.md)
-   [Old Candid-based Documentation](./candid_based_documentation.md)
    -   [Azle (Beta)](./azle.md)
    -   [Internet Computer Overview](./internet_computer_overview.md)
    -   [Canisters Overview](./canisters_overview.md)
    -   [Installation](./installation.md)
    -   [Hello World](./hello_world.md)
    -   [Deployment](./deployment_candid_based.md)
    -   [Examples](./examples.md)
    -   [Query Methods](./query_methods.md)
    -   [Update Methods](./update_methods.md)
    -   [Candid](./candid.md)
    -   [Stable Structures](./stable_structures.md)
    -   [Cross-canister](./cross_canister.md)
    -   [HTTP](./http.md)
    -   [Management Canister](./management_canister.md)
    -   [Canister Lifecycle](./canister_lifecycle.md)
    -   [Timers](./timers.md)
    -   [Cycles](./cycles.md)
    -   [Caveats](./caveats.md)
    -   [Reference](./reference/reference.md)
        -   [Bitcoin](./reference/bitcoin.md)
        -   [Call APIs](./reference/call_apis/call_apis.md)
            -   [accept message](./reference/call_apis/accept_message.md)
            -   [arg data raw](./reference/call_apis/arg_data_raw.md)
            -   [arg data raw size](./reference/call_apis/arg_data_raw_size.md)
            -   [call](./reference/call_apis/call.md)
            -   [call raw](./reference/call_apis/call_raw.md)
            -   [call raw 128](./reference/call_apis/call_raw128.md)
            -   [call with payment](./reference/call_apis/call_with_payment.md)
            -   [call with payment 128](./reference/call_apis/call_with_payment128.md)
            -   [caller](./reference/call_apis/caller.md)
            -   [method name](./reference/call_apis/method_name.md)
            -   [msg cycles accept](./reference/call_apis/msg_cycles_accept.md)
            -   [msg cycles accept 128](./reference/call_apis/msg_cycles_accept128.md)
            -   [msg cycles available](./reference/call_apis/msg_cycles_available.md)
            -   [msg cycles available 128](./reference/call_apis/msg_cycles_available128.md)
            -   [msg cycles refunded](./reference/call_apis/msg_cycles_refunded.md)
            -   [msg cycles refunded 128](./reference/call_apis/msg_cycles_refunded128.md)
            -   [notify](./reference/call_apis/notify.md)
            -   [notify raw](./reference/call_apis/notify_raw.md)
            -   [notify with payment 128](./reference/call_apis/notify_with_payment_128.md)
            -   [reject](./reference/call_apis/reject.md)
            -   [reject code](./reference/call_apis/reject_code.md)
            -   [reject message](./reference/call_apis/reject_message.md)
            -   [reply](./reference/call_apis/reply.md)
            -   [reply raw](./reference/call_apis/reply_raw.md)
        -   [Candid](./reference/candid/candid.md)
            -   [blob](./reference/candid/blob.md)
            -   [bool](./reference/candid/bool.md)
            -   [empty](./reference/candid/empty.md)
            -   [float32](./reference/candid/float32.md)
            -   [float64](./reference/candid/float64.md)
            -   [func](./reference/candid/func.md)
            -   [int](./reference/candid/int.md)
            -   [int8](./reference/candid/int8.md)
            -   [int16](./reference/candid/int16.md)
            -   [int32](./reference/candid/int32.md)
            -   [int64](./reference/candid/int64.md)
            -   [nat](./reference/candid/nat.md)
            -   [nat8](./reference/candid/nat8.md)
            -   [nat16](./reference/candid/nat16.md)
            -   [nat32](./reference/candid/nat32.md)
            -   [nat64](./reference/candid/nat64.md)
            -   [null](./reference/candid/null.md)
            -   [opt](./reference/candid/opt.md)
            -   [principal](./reference/candid/principal.md)
            -   [record](./reference/candid/record.md)
            -   [reserved](./reference/candid/reserved.md)
            -   [service](./reference/candid/service.md)
            -   [text](./reference/candid/text.md)
            -   [variant](./reference/candid/variant.md)
            -   [vec](./reference/candid/vec.md)
        -   [Canister APIs](./reference/canister_apis/canister_apis.md)
            -   [candid decode](./reference/canister_apis/candid_decode.md)
            -   [candid encode](./reference/canister_apis/candid_encode.md)
            -   [canister balance](./reference/canister_apis/canister_balance.md)
            -   [canister balance 128](./reference/canister_apis/canister_balance128.md)
            -   [canister version](./reference/canister_apis/canister_version.md)
            -   [canister id](./reference/canister_apis/canister_id.md)
            -   [data certificate](./reference/canister_apis/data_certificate.md)
            -   [instruction counter](./reference/canister_apis/instruction_counter.md)
            -   [is controller](./reference/canister_apis/is_controller.md)
            -   [performance counter](./reference/canister_apis/performance_counter.md)
            -   [print](./reference/canister_apis/print.md)
            -   [set certified data](./reference/canister_apis/set_certified_data.md)
            -   [time](./reference/canister_apis/time.md)
            -   [trap](./reference/canister_apis/trap.md)
        -   [Canister Methods](./reference/canister_methods/canister_methods.md)
            -   [heartbeat](./reference/canister_methods/heartbeat.md)
            -   [http_request](./reference/canister_methods/http_request.md)
            -   [http_request_update](./reference/canister_methods/http_request_update.md)
            -   [init](./reference/canister_methods/init.md)
            -   [inspect message](./reference/canister_methods/inspect_message.md)
            -   [post upgrade](./reference/canister_methods/post_upgrade.md)
            -   [pre upgrade](./reference/canister_methods/pre_upgrade.md)
            -   [query](./reference/canister_methods/query.md)
            -   [update](./reference/canister_methods/update.md)
        -   [Environment Variables](./reference/environment_variables.md)
        -   [Management Canister](./reference/management_canister/management_canister.md)
            -   [bitcoin_get_balance](./reference/management_canister/bitcoin_get_balance.md)
            -   [bitcoin_get_current_fee_percentiles](./reference/management_canister/bitcoin_get_current_fee_percentiles.md)
            -   [bitcoin_get_utxos](./reference/management_canister/bitcoin_get_utxos.md)
            -   [bitcoin_send_transaction](./reference/management_canister/bitcoin_send_transaction.md)
            -   [canister_status](./reference/management_canister/canister_status.md)
            -   [create_canister](./reference/management_canister/create_canister.md)
            -   [delete_canister](./reference/management_canister/delete_canister.md)
            -   [deposit_cycles](./reference/management_canister/deposit_cycles.md)
            -   [ecdsa_public_key](./reference/management_canister/ecdsa_public_key.md)
            -   [http_request](./reference/management_canister/http_request.md)
            -   [install_code](./reference/management_canister/install_code.md)
            -   [provisional_create_canister_with_cycles](./reference/management_canister/provisional_create_canister_with_cycles.md)
            -   [provisional_top_up_canister](./reference/management_canister/provisional_top_up_canister.md)
            -   [raw_rand](./reference/management_canister/raw_rand.md)
            -   [sign_with_ecdsa](./reference/management_canister/sign_with_ecdsa.md)
            -   [start_canister](./reference/management_canister/start_canister.md)
            -   [stop_canister](./reference/management_canister/stop_canister.md)
            -   [uninstall_code](./reference/management_canister/uninstall_code.md)
            -   [update_settings](./reference/management_canister/update_settings.md)
        -   [Plugins](./reference/plugins.md)
        -   [Stable Memory](./reference/stable_memory/stable_memory.md)
            -   [stable structures](./reference/stable_memory/stable_structures.md)
            -   [stable bytes](./reference/stable_memory/stable_bytes.md)
            -   [stable grow](./reference/stable_memory/stable_grow.md)
            -   [stable read](./reference/stable_memory/stable_read.md)
            -   [stable size](./reference/stable_memory/stable_size.md)
            -   [stable write](./reference/stable_memory/stable_write.md)
            -   [stable64 grow](./reference/stable_memory/stable64_grow.md)
            -   [stable64 read](./reference/stable_memory/stable64_read.md)
            -   [stable64 size](./reference/stable_memory/stable64_size.md)
            -   [stable64 write](./reference/stable_memory/stable64_write.md)
        -   [Timers](./reference/timers/timers.md)
            -   [clear timer](./reference/timers/clear_timer.md)
            -   [set timer](./reference/timers/set_timer.md)
            -   [set timer interval](./reference/timers/set_timer_interval.md)
        -   [Wasm Binary Optimization](./reference/wasm_binary_optimization.md)
